//
//  UIView+Geometry.m
//  Rotation
//
//  Created by Clemens Wagner on 20.06.15.
//  Copyright (c) 2015 Clemens Wagner. All rights reserved.
//

#import "UIView+Geometry.h"

@implementation UIView (Geometry)

- (CGPoint)midPoint {
    CGRect theBounds = self.bounds;
    return CGPointMake(CGRectGetMidX(theBounds),
                       CGRectGetMidY(theBounds));
}

- (CGFloat)angleWithPoint:(CGPoint)inPoint {
    CGPoint theCenter = [self midPoint];
    CGFloat theX = inPoint.x - theCenter.x;
    CGFloat theY = inPoint.y - theCenter.y;
    CGFloat theAngle = atan2f(theX, -theY);
    
    return theAngle < 0 ? theAngle + 2.0 * M_PI : theAngle;
}

@end
