//
//  GridView.m
//  Auto-Layout
//
//  Created by Clemens Wagner on 30.08.15.
//  Copyright © 2015 Clemens Wagner. All rights reserved.
//

#import "GridView.h"

@implementation GridView

- (void)layoutSubviews {
    NSArray *theViews = self.subviews;
    NSUInteger theCount = theViews.count;
    
    if(theCount > 0) {
        CGRect theBounds = self.bounds;
        CGFloat theSpace = self.space;
        NSUInteger theColumns = ceilf(sqrtf((float)theCount));
        NSUInteger theRows = (theCount + theColumns - 1) / theColumns;
        CGRect theFrame = CGRectMake(0.0, 0.0,
                                     (CGRectGetWidth(theBounds) - (theColumns - 1) *theSpace) / theColumns,
                                     (CGRectGetHeight(theBounds) - (theRows - 1) *theSpace) / theRows);
        NSUInteger theIndex = 0;
        
        for(UIView *theView in theViews) {
            ++theIndex;
            theView.frame = theFrame;
            if(theIndex % theColumns == 0) {
                theFrame.origin.x = 0.0;
                theFrame.origin.y += CGRectGetHeight(theFrame) + theSpace;
            }
            else {
                theFrame.origin.x += CGRectGetWidth(theFrame) + theSpace;
            }
        }
    }
}

@end
